import java.awt.EventQueue;

import javax.swing.*;

import java.awt.Panel;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Component;

import javax.swing.Box;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import com.jgoodies.forms.factories.DefaultComponentFactory;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import java.awt.Insets;
import java.awt.event.ActionEvent;


public class SimulationBoard {

	private JFrame frame;
	private static JPanel streetPanel;
	static JTextArea textAreaInfo;
	JTextArea textAreaStreet;
	
	String src_pylon = "images/pylon_small.jpeg";
	AutoPanel pylon_1 = new AutoPanel(src_pylon, 20, 6, 26, 35);
	AutoPanel pylon_2 = new AutoPanel(src_pylon, 80, 6, 26, 35);
	AutoPanel pylon_3 = new AutoPanel(src_pylon, 140, 6, 26, 35);
	AutoPanel pylon_4 = new AutoPanel(src_pylon, 200, 6, 26, 35);
	AutoPanel pylon_5 = new AutoPanel(src_pylon, 260, 6, 26, 35);
	AutoPanel pylon_6 = new AutoPanel(src_pylon, 320, 6, 26, 35);
	AutoPanel pylon_7 = new AutoPanel(src_pylon, 380, 6, 26, 35);
	AutoPanel pylon_8 = new AutoPanel(src_pylon, 440, 6, 26, 35);
	AutoPanel pylon_9 = new AutoPanel(src_pylon, 500, 6, 26, 35);
	AutoPanel pylon_10 = new AutoPanel(src_pylon, 560, 6, 26, 35);
	AutoPanel pylon_11 = new AutoPanel(src_pylon, 620, 6, 26, 35);
	AutoPanel pylon_12 = new AutoPanel(src_pylon, 680, 6, 26, 35);
	AutoPanel pylon_13 = new AutoPanel(src_pylon, 740, 6, 26, 35);
	AutoPanel pylon_14 = new AutoPanel(src_pylon, 800, 6, 26, 35);
	AutoPanel pylon_15 = new AutoPanel(src_pylon, 860, 6, 26, 35);
	AutoPanel pylon_16 = new AutoPanel(src_pylon, 920, 6, 26, 35);
	AutoPanel pylon_17 = new AutoPanel(src_pylon, 980, 6, 26, 35);
	AutoPanel pylon_18 = new AutoPanel(src_pylon, 1040, 6, 26, 35);
	AutoPanel pylon_19 = new AutoPanel(src_pylon, 1100, 6, 26, 35);
	AutoPanel pylon_20 = new AutoPanel(src_pylon, 1160, 6, 26, 35);

	private static EinspurigeSimulation Simulation1;
	private static ZweispurigeSimulation Simulation2;
	
	private static int simulation = 0;
	private int generation = 0;
	private String img ="";
	
	private Auto[] generation1 = new Auto[20];
	private Auto[][] generation2 = new Auto[20][2];
	private int anzahlAutos = 5;
	private int troedelfaktor = 0;
	
	private SpinnerModel autoModel;
	private SpinnerModel troedelModel;
	JSpinner spinnerAutos;
	JSpinner spinnerTroedeln;
	private JButton btnZufaelligeStrasse;
	private JButton btnNaechsteGeneration;
	private JButton btnSpielfeldLeeren;
	private JRadioButton rdbtnZufaelligeStrasse;
	private JRadioButton rdbtnEigeneStrasse;
	JButton btnSchwarz;
	JButton btnBlau;
	JButton btnTuerkis;
	JButton btnLila;
	JButton btnOrange;
	JButton btnRot;
	JButton btnGruen;
	JButton btnOK;
	MouseAdapter clicked = null;
	
	private final String[] srcs = {"images/auto_schwarz_small.png", "images/auto_lila_small.png", "images/auto_tuerkis_small.png", 
								   "images/auto_orange_small.png", "images/auto_rot_small.png", "images/auto_gruen_small.png", "images/auto_blau_small.png"};
	
	private final Action action1 = new SwingActionEinspurig();
	private final Action action2 = new SwingActionZweispurig();
	
	/**
	 * Create the application.
	 */
	public SimulationBoard() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		
		frame = new JFrame();
		frame.getContentPane().setVisible(false);
		frame.getContentPane().setBackground(Color.WHITE);
		frame.setMinimumSize(new Dimension(1210, 600));
		frame.setSize(new Dimension(1210, 600));
		frame.setBounds(100, 100, 450, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.Y_AXIS));
		
		
		Component verticalStrut_1 = Box.createVerticalStrut(20);
		frame.getContentPane().add(verticalStrut_1);
		
		JLabel lblNewJgoodiesTitle = DefaultComponentFactory.getInstance().createTitle("Verkehrssimulation mit zellul\u00E4ren Automaten");
		lblNewJgoodiesTitle.setAlignmentX(Component.CENTER_ALIGNMENT);
		lblNewJgoodiesTitle.setFont(new Font("Lucida Grande", Font.BOLD, 15));
		frame.getContentPane().add(lblNewJgoodiesTitle);
		
		Component verticalStrut = Box.createVerticalStrut(20);
		frame.getContentPane().add(verticalStrut);
		
		streetPanel = new SimulationPanel();
		streetPanel.setOpaque(false);
		
		streetPanel.setSize(new Dimension(1202, 100));
		streetPanel.setMaximumSize(new Dimension(1206, 86));
		streetPanel.setMinimumSize(new Dimension(1206, 86));
		frame.getContentPane().add(streetPanel);
		streetPanel.setLayout(null);
		
		Component verticalStrut_2 = Box.createVerticalStrut(20);
		frame.getContentPane().add(verticalStrut_2);
		
		Panel panel = new Panel();
		panel.setBackground(Color.WHITE);
		panel.setMaximumSize(new Dimension(1200, 300));
		frame.getContentPane().add(panel);
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		
		Component horizontalStrut = Box.createHorizontalStrut(20);
		panel.add(horizontalStrut);
		
		textAreaInfo = new JTextArea();
		textAreaInfo.setToolTipText("");
		JScrollPane sp1 = new JScrollPane(textAreaInfo);
		sp1.setMinimumSize(new Dimension(350,450));
		sp1.setMaximumSize(new Dimension(350, 450));
		textAreaInfo.setText("Noch keine Simulation gestartet...");
		textAreaInfo.setEditable(false);
		panel.add(sp1);
		
		textAreaStreet = new JTextArea();
		textAreaStreet.setToolTipText("");
		JScrollPane sp2 = new JScrollPane(textAreaStreet);
		sp2.setMinimumSize(new Dimension(350, 450));
		sp2.setMaximumSize(new Dimension(350, 450));
		textAreaStreet.setText("Noch keine Simulation gestartet...");
		textAreaStreet.setEditable(false);
		panel.add(sp2);
				
		Component horizontalStrut_1 = Box.createHorizontalStrut(50);
		panel.add(horizontalStrut_1);
		
		Panel btnPanel = new Panel();
		panel.add(btnPanel);
		btnPanel.setBackground(Color.WHITE);
		btnPanel.setMaximumSize(new Dimension(500, 450));
		btnPanel.setPreferredSize(new Dimension(500, 450));
		btnPanel.setSize(new Dimension(500, 450));
		btnPanel.setMinimumSize(new Dimension(500, 450));
		GridBagLayout gbl_btnPanel = new GridBagLayout();
		gbl_btnPanel.columnWidths = new int[]{0, 0, 0, 0, 0, 0, 0};
		gbl_btnPanel.rowHeights = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_btnPanel.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_btnPanel.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		btnPanel.setLayout(gbl_btnPanel);
		
		JLabel lblTroedelfaktor = new JLabel("Trodelfaktor (in %):");
		GridBagConstraints gbc_lblTroedelfaktor = new GridBagConstraints();
		gbc_lblTroedelfaktor.anchor = GridBagConstraints.WEST;
		gbc_lblTroedelfaktor.insets = new Insets(0, 0, 5, 5);
		gbc_lblTroedelfaktor.gridx = 0;
		gbc_lblTroedelfaktor.gridy = 0;
		btnPanel.add(lblTroedelfaktor, gbc_lblTroedelfaktor);
		
		JLabel lblAnzahlDerAutos = new JLabel("Anzahl der Autos:");
		GridBagConstraints gbc_lblAnzahlDerAutos = new GridBagConstraints();
		gbc_lblAnzahlDerAutos.anchor = GridBagConstraints.EAST;
		gbc_lblAnzahlDerAutos.insets = new Insets(0, 0, 5, 5);
		gbc_lblAnzahlDerAutos.gridx = 0;
		gbc_lblAnzahlDerAutos.gridy = 4;
		btnPanel.add(lblAnzahlDerAutos, gbc_lblAnzahlDerAutos);
		
		troedelModel = new SpinnerNumberModel(troedelfaktor, troedelfaktor, troedelfaktor+100, 5); 
		spinnerTroedeln = new JSpinner(troedelModel);
		spinnerTroedeln.setToolTipText("Troedelfaktor in Prozent, mit dem die Autos trödeln können.");
		GridBagConstraints gbc_spinnerTroedeln = new GridBagConstraints();
		gbc_spinnerTroedeln.insets = new Insets(0, 0, 5, 5);
		gbc_spinnerTroedeln.gridx = 1;
		gbc_spinnerTroedeln.gridy = 0;
		btnPanel.add(spinnerTroedeln, gbc_spinnerTroedeln);
		
		autoModel = new SpinnerNumberModel(anzahlAutos, anzahlAutos-4, anzahlAutos+14, 1);  
		spinnerAutos = new JSpinner(autoModel);
		spinnerAutos.setToolTipText("Anzahl der Autos, die auf der Straße generiert werden soll.");
		GridBagConstraints gbc_spinnerAutos = new GridBagConstraints();
		gbc_spinnerAutos.insets = new Insets(0, 0, 5, 5);
		gbc_spinnerAutos.gridx = 1;
		gbc_spinnerAutos.gridy = 4;
		btnPanel.add(spinnerAutos, gbc_spinnerAutos);
		lblAnzahlDerAutos.setLabelFor(spinnerAutos);
		
		/*
		 * BUTTON Simulation starten (eigene Straße):
		 */
		btnOK = new JButton("Simulation starten");
		btnOK.setToolTipText("Startet eine Simulation mit der eigenen Straße und dem angegebenen Trödelfaktor.");
		btnOK.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent arg0) {
				if(btnOK.isEnabled()) {
					btnOK.setEnabled(false);
					spinnerTroedeln.setEnabled(false);
					//Einspurige Simulation
					if(simulation ==1) {
						int auto = 0;
						for(int i=0; i<generation1.length; i++) {
							if(generation1[i] != null) {
								auto++;
							}
						} 
						if(auto > 0) {
							btnZufaelligeStrasse.setEnabled(false);
							btnNaechsteGeneration.setEnabled(true);
							btnSpielfeldLeeren.setEnabled(true);
							Simulation1.setAktuelleGeneration(generation1);
							textAreaInfo.setText("");
							textAreaStreet.setText("");
							setStreetText(generation1);
						}
					//Zweispurige Simulation
					} else {
						int auto = 0;
						for(int i=0; i<generation2.length; i++) {
							for(int j=0; j<generation2[0].length; j++) {
								if(generation2[i][j] != null) {
									auto++;
								}
							}
						}
						if(auto > 0) {
							btnZufaelligeStrasse.setEnabled(false);
							btnNaechsteGeneration.setEnabled(true);
							btnSpielfeldLeeren.setEnabled(true);
							Simulation2.setAktuelleGeneration(generation2);
							textAreaInfo.setText("");
							textAreaStreet.setText("");
							setStreetText(generation2);
						}
					}
				} else {
					btnZufaelligeStrasse.setEnabled(true);
				}
			}
		});
		btnOK.setEnabled(false);
		GridBagConstraints gbc_btnOK = new GridBagConstraints();
		gbc_btnOK.insets = new Insets(0, 0, 5, 5);
		gbc_btnOK.gridx = 2;
		gbc_btnOK.gridy = 5;
		btnPanel.add(btnOK, gbc_btnOK);
		
		/*
		 * BUTTON Simulation starten (zufällige Straße):
		 */
		btnZufaelligeStrasse = new JButton("Simulation starten");
		btnZufaelligeStrasse.setToolTipText("Startet die Simulaition einer zufälligen Straße mit dem angegebenen Trödelfaktor und der angegebenen Anzahl der Autos.");
		btnZufaelligeStrasse.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnZufaelligeStrasse.isEnabled()){
					Set<Integer> numberSet = new HashSet<Integer>();
					Random zufall = new Random();
					anzahlAutos = (Integer) autoModel.getValue();
					troedelfaktor = (Integer) troedelModel.getValue();
					generation = 0;
					if(simulation == 1){
						Simulation1 = new EinspurigeSimulation(troedelfaktor);
						System.out.println(troedelfaktor);
						generation1 = Simulation1.getAktuelleGeneration();
						//HashSet mit "anzahlAutos" zufälligen Zahlen im Intevall [0,19] befüllen, an deren Stellen die Autos platziert werden.
						while (numberSet.size() < anzahlAutos) {
							int zahl = zufall.nextInt(20);
							numberSet.add(zahl);
						}
						int auto = 0;
						for (Integer elem : numberSet) {
						    int geschwindigkeit = zufall.nextInt(6);
						    int src = zufall.nextInt(7);
							generation1[elem] = new Auto(new AutoPanel(), srcs[src], geschwindigkeit, (65+auto));
							auto++;
						}
						initialisiereAutos(generation1);
						Simulation1.setAktuelleGeneration(generation1);
						textAreaInfo.setText("");
						textAreaStreet.setText("");
						setStreetText(generation1);
					} else {
						Simulation2 = new ZweispurigeSimulation(troedelfaktor);
						generation2 = Simulation2.getAktuelleGeneration();
						//HashSet mit "anzahlAutos" zufälligen Zahlen im Intevall [0,19] befüllen, an deren Stellen die Autos platziert werden.
						while (numberSet.size() < anzahlAutos) {
							int zahl = zufall.nextInt(20);
							numberSet.add(zahl);
						}
						int auto = 0;
						for (Integer elem : numberSet) {
						    int geschwindigkeit = zufall.nextInt(6);
						    int src = zufall.nextInt(7);
							generation2[elem][1] = new Auto(new AutoPanel(), srcs[src], geschwindigkeit, (65+auto));
							auto++;
						}
						initialisiereAutos(generation2);
						Simulation2.setAktuelleGeneration(generation2);
						textAreaInfo.setText("");
						textAreaStreet.setText("");
						setStreetText(generation2);
					}
					btnNaechsteGeneration.setEnabled(true);
					btnSpielfeldLeeren.setEnabled(true);
					btnZufaelligeStrasse.setEnabled(false);
					spinnerAutos.setEnabled(false);
					spinnerTroedeln.setEnabled(false);
				}
			}
		});
		GridBagConstraints gbc_btnZufaelligeStrasse = new GridBagConstraints();
		gbc_btnZufaelligeStrasse.insets = new Insets(0, 0, 5, 5);
		gbc_btnZufaelligeStrasse.gridx = 2;
		gbc_btnZufaelligeStrasse.gridy = 3;
		btnPanel.add(btnZufaelligeStrasse, gbc_btnZufaelligeStrasse);
		
		rdbtnZufaelligeStrasse = new JRadioButton("Zufällige Straße");
		rdbtnZufaelligeStrasse.setToolTipText("Ermöglicht eine zufällige Simulation mit dem angegebenem Trödelfaktor und der angegebenen Anzahl an Autos.");
		rdbtnZufaelligeStrasse.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if(simulation == 1){
					for(int i=0; i<generation1.length; i++) {
						if(generation1[i] != null) {
							streetPanel.remove(generation1[i].getAutoPanel());
							generation1[i] = null;
						}
					}
				} else {
					for(int i=0; i<generation2.length; i++) {
						for(int j=0; j<generation2[0].length; j++) {
							if(generation2[i][j] != null) {
								streetPanel.remove(generation2[i][j].getAutoPanel());
								generation2[i][j] = null;
							}
						}
					}
				}
				streetPanel.setBackground(Color.WHITE);
				textAreaStreet.setText("Noch keine Simulation gestartet...");
				textAreaInfo.setText("Noch keine Simulation gestartet...");
				if(arg0.getStateChange() == 1){
					btnZufaelligeStrasse.setEnabled(true);
					spinnerAutos.setEnabled(true);
					spinnerTroedeln.setEnabled(true);
				} else {
					btnZufaelligeStrasse.setEnabled(false);
				}
			}
		});
		rdbtnZufaelligeStrasse.setSelected(true);
		GridBagConstraints gbc_rdbtnZufaelligeStrasse = new GridBagConstraints();
		gbc_rdbtnZufaelligeStrasse.anchor = GridBagConstraints.WEST;
		gbc_rdbtnZufaelligeStrasse.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnZufaelligeStrasse.gridx = 0;
		gbc_rdbtnZufaelligeStrasse.gridy = 3;
		btnPanel.add(rdbtnZufaelligeStrasse, gbc_rdbtnZufaelligeStrasse);
		
		rdbtnEigeneStrasse = new JRadioButton("Eigene Straße");
		rdbtnEigeneStrasse.setToolTipText("Ermöglicht eine eigene Simulation mit dem angegebenen Trödelfaktor.");
		rdbtnEigeneStrasse.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if(simulation == 1){
					for(int i=0; i<generation1.length; i++) {
						if(generation1[i] != null) {
							streetPanel.remove(generation1[i].getAutoPanel());
							generation1[i] = null;
						}
					}
				} else {
					for(int i=0; i<generation2.length; i++) {
						for(int j=0; j<generation2[0].length; j++) {
							if(generation2[i][j] != null) {
								streetPanel.remove(generation2[i][j].getAutoPanel());
								generation2[i][j] = null;
							}
						}
					}
				}
				streetPanel.setBackground(Color.WHITE);
				textAreaStreet.setText("Noch keine Simulation gestartet...");
				textAreaInfo.setText("Noch keine Simulation gestartet...");
				img = "";
				if(arg0.getStateChange() == 1 ){
					btnZufaelligeStrasse.setEnabled(false);
					spinnerAutos.setEnabled(false);
					spinnerTroedeln.setEnabled(true);
					btnNaechsteGeneration.setEnabled(false);
					btnSpielfeldLeeren.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					
					streetPanel.addMouseListener(clicked = new MouseAdapter() {
						public void mouseClicked(MouseEvent e) {
							int x,y;
							final int a;
							final int b;
							x=e.getX();
							y=e.getY();
							// Ermittle aus der x und y Position der Maus die Zelle des Automaten,
							// in die geklickt wurde, und ändere ihren Zustand.
							a=x/60;
							b=y/40;
							System.out.println("(" + a + "," + b + ")");
							int auto = 0;
							// Einspurgie Simulation
							if(simulation == 1) {
								for(int i=0; i<generation1.length; i++) {
									if(generation1[i] != null) {
										auto++;
									}
								}
								if((a>=0) && (a<20) && (b==1) && img!="" && generation1[a] == null) { // Nur, wenn im Spielfeld geklickt und ein Auto gewählt wurde
									generation1[a] = new Auto(new AutoPanel(), img, 0, (65+auto));
									final AutoPanel currentAutoPanel = generation1[a].getAutoPanel();
									currentAutoPanel.updateAuto(generation1[a].getSrc(), 8+a*60, 50, 50, 28, generation1[a].getGeschwindigkeit()+"", generation1[a].getNr());
									currentAutoPanel.addMouseListener(new MouseAdapter() {
										@Override
										public void mouseClicked(MouseEvent e) {
											if(currentAutoPanel.getSpeed() == -1){
												streetPanel.remove(generation1[a].getAutoPanel());
												generation1[a] = null;
												int auto = 0;
												for(int i=0; i<generation1.length; i++) {
													if(generation1[i] != null) {
														auto++;
													}
												}
												if(auto == 0) {
													btnOK.setEnabled(false);
												}
											} else {
												generation1[a].setGeschwindigkeit(currentAutoPanel.getSpeed());
											}
										}
									});
									streetPanel.add(currentAutoPanel);
									currentAutoPanel.repaint();
									btnOK.setEnabled(true);
								}
							// Zweispurige Simulation
							} else {
								for(int i=0; i<generation2.length; i++) {
									for(int j=0; j<generation2[0].length; j++) {
										if(generation2[i][j] != null) {
											auto++;
										}
									}
								}
								if((a>=0) && (a<20) && (b==0 || b==1) && img!="" && generation2[a][b] == null) { // Nur, wenn im Spielfeld geklickt und ein Auto gewählt wurde
									generation2[a][b] = new Auto(new AutoPanel(), img, 0, (65+auto));
									final AutoPanel currentAutoPanel = generation2[a][b].getAutoPanel();
									currentAutoPanel.updateAuto(generation2[a][b].getSrc(), 8+a*60, 10+b*40, 50, 28, generation2[a][b].getGeschwindigkeit()+"", generation2[a][b].getNr());
									currentAutoPanel.addMouseListener(new MouseAdapter() {
										@Override
										public void mouseClicked(MouseEvent e) {
											if(currentAutoPanel.getSpeed() == -1){
												streetPanel.remove(generation2[a][b].getAutoPanel());
												generation2[a][b] = null;
												int auto = 0;
												for(int i=0; i<generation2.length; i++) {
													for(int j=0; j<generation2[0].length; j++) {
														if(generation2[i][j] != null) {
															auto++;
														}
													}
												}
												if(auto == 0) {
													btnOK.setEnabled(false);
												}
											} else {
												generation2[a][b].setGeschwindigkeit(currentAutoPanel.getSpeed());
											}
										}
									});
									streetPanel.add(currentAutoPanel);
									currentAutoPanel.repaint();
									btnOK.setEnabled(true);
								}
							}
						}
					});
				} else {
					btnZufaelligeStrasse.setEnabled(true);
					btnSchwarz.setEnabled(false);
					btnTuerkis.setEnabled(false);
					btnRot.setEnabled(false);
					btnOrange.setEnabled(false);
					btnGruen.setEnabled(false);
					btnLila.setEnabled(false);
					btnBlau.setEnabled(false);
					btnOK.setEnabled(false);
					
					streetPanel.removeMouseListener(clicked);
				}
			}
		});
		GridBagConstraints gbc_rdbtnEigeneStrasse = new GridBagConstraints();
		gbc_rdbtnEigeneStrasse.anchor = GridBagConstraints.WEST;
		gbc_rdbtnEigeneStrasse.insets = new Insets(0, 0, 5, 5);
		gbc_rdbtnEigeneStrasse.gridx = 0;
		gbc_rdbtnEigeneStrasse.gridy = 5;
		btnPanel.add(rdbtnEigeneStrasse, gbc_rdbtnEigeneStrasse);
		
		ButtonGroup group = new ButtonGroup();
		group.add(rdbtnEigeneStrasse);
		group.add(rdbtnZufaelligeStrasse);
		
		btnLila = new JButton("");
		btnLila.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnLila.isEnabled()) {
					btnLila.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_lila_small.png";
				}
			}
		});
		btnLila.setEnabled(false);
		btnLila.setIcon(new ImageIcon("images/auto_Lila_small.png"));
		GridBagConstraints gbc_btnLila = new GridBagConstraints();
		gbc_btnLila.insets = new Insets(0, 0, 5, 5);
		gbc_btnLila.gridx = 0;
		gbc_btnLila.gridy = 7;
		btnPanel.add(btnLila, gbc_btnLila);
		
		btnBlau = new JButton("");
		btnBlau.setEnabled(false);
		btnBlau.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnBlau.isEnabled()) {
					btnBlau.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					img = "images/auto_blau_small.png";
				}
			}
		});
		btnBlau.setIcon(new ImageIcon("images/auto_blau_small.png"));
		GridBagConstraints gbc_btnBlau = new GridBagConstraints();
		gbc_btnBlau.insets = new Insets(0, 0, 5, 5);
		gbc_btnBlau.gridx = 1;
		gbc_btnBlau.gridy = 6;
		btnPanel.add(btnBlau, gbc_btnBlau);
		
		btnGruen = new JButton("");
		btnGruen.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnGruen.isEnabled()) {
					btnGruen.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_gruen_small.png";
				}
			}
		});
		btnGruen.setEnabled(false);
		btnGruen.setIcon(new ImageIcon("images/auto_gruen_small.png"));
		GridBagConstraints gbc_btnGruen = new GridBagConstraints();
		gbc_btnGruen.insets = new Insets(0, 0, 5, 5);
		gbc_btnGruen.gridx = 2;
		gbc_btnGruen.gridy = 6;
		btnPanel.add(btnGruen, gbc_btnGruen);
		
		btnOrange = new JButton("");
		btnOrange.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnOrange.isEnabled()) {
					btnOrange.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_orange_small.png";
				}
			}
		});
		btnOrange.setEnabled(false);
		btnOrange.setIcon(new ImageIcon("images/auto_Orange_small.png"));
		GridBagConstraints gbc_btnOrange = new GridBagConstraints();
		gbc_btnOrange.insets = new Insets(0, 0, 5, 5);
		gbc_btnOrange.gridx = 1;
		gbc_btnOrange.gridy = 7;
		btnPanel.add(btnOrange, gbc_btnOrange);
		
		btnTuerkis = new JButton("");
		btnTuerkis.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnTuerkis.isEnabled()) {
					btnTuerkis.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_tuerkis_small.png";
				}
			}
		});
		btnTuerkis.setEnabled(false);
		btnTuerkis.setIcon(new ImageIcon("images/auto_tuerkis_small.png"));
		GridBagConstraints gbc_btnTuerkis = new GridBagConstraints();
		gbc_btnTuerkis.insets = new Insets(0, 0, 5, 5);
		gbc_btnTuerkis.gridx = 0;
		gbc_btnTuerkis.gridy = 8;
		btnPanel.add(btnTuerkis, gbc_btnTuerkis);
		
		btnRot = new JButton("");
		btnRot.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnRot.isEnabled()) {
					btnRot.setEnabled(false);
					btnSchwarz.setEnabled(true);
					btnTuerkis.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_rot_small.png";
				}
			}
		});
		btnRot.setEnabled(false);
		btnRot.setIcon(new ImageIcon("images/auto_rot_small.png"));
		GridBagConstraints gbc_btnRot = new GridBagConstraints();
		gbc_btnRot.insets = new Insets(0, 0, 5, 5);
		gbc_btnRot.gridx = 2;
		gbc_btnRot.gridy = 7;
		btnPanel.add(btnRot, gbc_btnRot);
		
		btnSchwarz = new JButton("");
		btnSchwarz.setEnabled(false);
		btnSchwarz.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnSchwarz.isEnabled()) {
					btnSchwarz.setEnabled(false);
					btnTuerkis.setEnabled(true);
					btnRot.setEnabled(true);
					btnOrange.setEnabled(true);
					btnGruen.setEnabled(true);
					btnLila.setEnabled(true);
					btnBlau.setEnabled(true);
					img = "images/auto_schwarz_small.png";
				}
			}
		});
		btnSchwarz.setIcon(new ImageIcon("images/auto_schwarz_small.png"));
		GridBagConstraints gbc_btnSchwarz = new GridBagConstraints();
		gbc_btnSchwarz.insets = new Insets(0, 0, 5, 5);
		gbc_btnSchwarz.gridx = 0;
		gbc_btnSchwarz.gridy = 6;
		btnPanel.add(btnSchwarz, gbc_btnSchwarz);
		
		/*
		 * BUTTON Spielfeld leeren
		 */
		btnSpielfeldLeeren = new JButton("Straße leeren");
		btnSpielfeldLeeren.setToolTipText("Löscht alle Autos, die sich auf der Straße befinden, sowie die Textfelder.");
		btnSpielfeldLeeren.setEnabled(false);
		btnSpielfeldLeeren.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnSpielfeldLeeren.isEnabled()){
					if(simulation == 1){
						for(int i=0; i<generation1.length; i++) {
							if(generation1[i] != null) {
								streetPanel.remove(generation1[i].getAutoPanel());
								generation1[i] = null;
							}
						}
					} else {
						for(int i=0; i<generation2.length; i++) {
							for(int j=0; j<generation2[0].length; j++) {
								if(generation2[i][j] != null) {
									streetPanel.remove(generation2[i][j].getAutoPanel());
									generation2[i][j] = null;
								}
							}
						}
					}
					streetPanel.setBackground(Color.WHITE);
					textAreaStreet.setText("Noch keine Simulation gestartet...");
					textAreaInfo.setText("Noch keine Simulation gestartet...");
					if(rdbtnZufaelligeStrasse.isSelected()) {
						btnZufaelligeStrasse.setEnabled(true);
						spinnerAutos.setEnabled(true);
						spinnerTroedeln.setEnabled(true);
					} else {
						btnOK.setEnabled(true);
						spinnerAutos.setEnabled(false);
						spinnerTroedeln.setEnabled(true);
					}
					btnNaechsteGeneration.setEnabled(false);
					btnSpielfeldLeeren.setEnabled(false);
					generation = 0;
				}
			}
		});
		
		/*
		 * BUTTON Nächste Generation
		 */
		btnNaechsteGeneration = new JButton("N\u00E4chste Generation");
		btnNaechsteGeneration.setToolTipText("Berechnet die nächste Generation und gibt sie auf der Straße und in den Textfeldern aus.");
		btnNaechsteGeneration.setEnabled(false);
		btnNaechsteGeneration.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent arg0) {
				if(btnNaechsteGeneration.isEnabled()){
					generation++;
					if(simulation == 1){
						textAreaInfo.setText(textAreaInfo.getText() + generation + ". Generation: \n");
						Simulation1.berechneNaechsteGeneration();				
						generation1 = Simulation1.getAktuelleGeneration();
						aktualisiereAutos(generation1);
						textAreaInfo.setText(textAreaInfo.getText() + "\n");
						setStreetText(generation1);
					} else {
						textAreaInfo.setText(textAreaInfo.getText() + generation + ". Generation: \n");
						Simulation2.berechneNaechsteGeneration();				
						generation2 = Simulation2.getAktuelleGeneration();
						aktualisiereAutos(generation2);
						textAreaInfo.setText(textAreaInfo.getText() + "\n");
						setStreetText(generation2);
					}
				}
			}
		});
		GridBagConstraints gbc_btnNaechsteGeneration = new GridBagConstraints();
		gbc_btnNaechsteGeneration.insets = new Insets(0, 0, 5, 5);
		gbc_btnNaechsteGeneration.gridx = 0;
		gbc_btnNaechsteGeneration.gridy = 10;
		btnPanel.add(btnNaechsteGeneration, gbc_btnNaechsteGeneration);
		GridBagConstraints gbc_btnSpielfeldLeeren = new GridBagConstraints();
		gbc_btnSpielfeldLeeren.insets = new Insets(0, 0, 5, 5);
		gbc_btnSpielfeldLeeren.gridx = 2;
		gbc_btnSpielfeldLeeren.gridy = 10;
		btnPanel.add(btnSpielfeldLeeren, gbc_btnSpielfeldLeeren);
		
		/*
		 * MENU
		 */
		JMenuBar menuBar = new JMenuBar();
		frame.setJMenuBar(menuBar);
		
		JMenu mnSimulationWaehlen = new JMenu("Simulation w\u00E4hlen");
		menuBar.add(mnSimulationWaehlen);
		
		JMenuItem mntmEinspurigeStrasse = new JMenuItem("Einspurige Stra\u00DFe");
		mntmEinspurigeStrasse.setAction(action1);
		mnSimulationWaehlen.add(mntmEinspurigeStrasse);
		
		JMenuItem mntmZweispurigeStrasse = new JMenuItem("Zweispurige Stra\u00DFe");
		mntmZweispurigeStrasse.setAction(action2);
		mnSimulationWaehlen.add(mntmZweispurigeStrasse);
	}
	
	/**
	 * EINSPURIGE SIMULATION: Aktualisiert alle Autos, die sich auf der Straße befinden.
	 * @param generation enthält Information über die Befüllung der Straße.
	 */
	public void aktualisiereAutos(Auto[] generation) {
		AutoPanel currentAutoPanel;
		Auto auto;
		for(int i=0; i<generation.length; i++) {
			if(generation[i] != null) {
				auto = generation[i];
				currentAutoPanel = auto.getAutoPanel();
				currentAutoPanel.updateAuto(auto.getSrc(), 8+i*60, 50, 50, 28, auto.getGeschwindigkeit()+"", auto.getNr());
				currentAutoPanel.repaint();
			}
		}
		streetPanel.setBackground(Color.WHITE);
	}
	
	/**
	 * ZWEISPURIGE SIMULATION: Aktualisiert alle Autos, die sich auf der Straße befinden.
	 * @param generation enthält Information über die Befüllung der Straße.
	 */
	public void aktualisiereAutos(Auto[][] generation) {
		AutoPanel currentAutoPanel;
		Auto auto;
		for(int i=0; i<generation.length; i++) {
			for(int j=0; j<generation[0].length; j++) {
				if(generation[i][j] != null) {
					auto = generation[i][j];
					currentAutoPanel = auto.getAutoPanel();
					if(j == 0) {
						currentAutoPanel.updateAuto(auto.getSrc(), 8+i*60, 10, 50, 28, auto.getGeschwindigkeit()+"", auto.getNr());
					} else {
						currentAutoPanel.updateAuto(auto.getSrc(), 8+i*60, 50, 50, 28, auto.getGeschwindigkeit()+"", auto.getNr());
					}
					currentAutoPanel.repaint();
				}
			}
		}
	}
	
	/**
	 * EINSPURIGE SIMULATION: Initialisiert die ImagePanels der Autos.
	 * @param generation Enthält die Daten der aktuellen Generation: -1= kein Auto | 0-5=Auto mit entsprechender Geschwindigkeit
	 */
	public void initialisiereAutos(Auto[] generation) {
		Auto auto;
		AutoPanel currentAutoPanel;
		for(int i=0; i<generation.length; i++) {
			if(generation[i] != null) {
				auto = generation[i];
				currentAutoPanel = auto.getAutoPanel();
				currentAutoPanel.updateAuto(auto.getSrc(), 8+i*60, 50, 50, 28, auto.getGeschwindigkeit()+"", auto.getNr());
				streetPanel.add(currentAutoPanel);
				currentAutoPanel.repaint();
			}
		}
		streetPanel.setBackground(Color.WHITE);
	}
	
	/**
	 * ZWEISPURIGE SIMULATION: Initialisiert die ImagePanels der Autos.
	 * @param generation Enthält die Daten der aktuellen Generation: -1= kein Auto | 0-5=Auto mit entsprechender Geschwindigkeit
	 */
	public void initialisiereAutos(Auto[][] generation) {
		Auto auto;
		AutoPanel currentAutoPanel;
		for(int i=0; i<generation.length; i++) {
			for(int j=0; j<generation[0].length; j++) {
				if(generation[i][j] != null) {
					auto = generation[i][j];
					currentAutoPanel = auto.getAutoPanel();
					currentAutoPanel.updateAuto(auto.getSrc(), 8+i*60, 50, 50, 28, auto.getGeschwindigkeit()+"", auto.getNr());
					streetPanel.add(currentAutoPanel);
					currentAutoPanel.repaint();
				}
			}
		}
	}
	
	/**
	 * EINSPURIGE SIMULATION: Realisiert die Ausgabe der Straße der Form: - 3 - - 5 - - 1 -.
	 * @param gen enthät die Daten der aktuellen Generation.
	 */
	public void setStreetText(Auto[] gen) {
		if(generation < 10) {
			textAreaStreet.setText(textAreaStreet.getText() + "  " + generation + ": ");
		} else {
			textAreaStreet.setText(textAreaStreet.getText() +generation + ": ");
		}
		for(int i=0; i<gen.length; i++) {
			if(gen[i] != null) {
				textAreaStreet.setText(textAreaStreet.getText() + gen[i].getGeschwindigkeit() + " ");
			} else {
				textAreaStreet.setText(textAreaStreet.getText() + "- ");
			}
		}
		textAreaStreet.setText(textAreaStreet.getText() + "\n");
	}
	
	/**
	 * ZWEISPURIGE SIMULATION: Realisiert die Ausgabe der zweispurigen Straße der Form: - 3 - - 5 - - 1 -
	 * 																					1 1 - 3 - - 4 - -.
	 * @param gen enthät die Daten der aktuellen Generation.
	 */
	public void setStreetText(Auto[][] gen) {
		if(generation < 10) {
			textAreaStreet.setText(textAreaStreet.getText() + "  " + generation + ": ");
		} else {
			textAreaStreet.setText(textAreaStreet.getText() + generation + ": ");
		}
		for(int i=0; i<gen[0].length; i++) {
			for(int j=0; j<gen.length; j++) {
				if(gen[j][i] != null) {
					textAreaStreet.setText(textAreaStreet.getText() + gen[j][i].getGeschwindigkeit() + " ");
				} else {
					textAreaStreet.setText(textAreaStreet.getText() + "- ");
				}
			}
			textAreaStreet.setText(textAreaStreet.getText() + "\n");
			textAreaStreet.setText(textAreaStreet.getText() + "      ");
		}
		textAreaStreet.setText(textAreaStreet.getText() + "\n");
	}
	
	public static void write(String text) {
		textAreaInfo.setText(textAreaInfo.getText() + text + "\n");
	}
	
	public static int getSimulation() {
		return simulation;
	}
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					SimulationBoard window = new SimulationBoard();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}
	
	
	private class SwingActionEinspurig extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 4697827833713481639L;
		public SwingActionEinspurig() {
			putValue(NAME, "Einspurige Straße");
			putValue(SHORT_DESCRIPTION, "Öffnet die Simulation zur einspurigen Straße.");
		}
		public void actionPerformed(ActionEvent e) {
			streetPanel.add(pylon_1);
			streetPanel.add(pylon_2);
			streetPanel.add(pylon_3);
			streetPanel.add(pylon_4);
			streetPanel.add(pylon_5);
			streetPanel.add(pylon_6);
			streetPanel.add(pylon_7);
			streetPanel.add(pylon_8);
			streetPanel.add(pylon_9);
			streetPanel.add(pylon_10);
			streetPanel.add(pylon_11);
			streetPanel.add(pylon_12);
			streetPanel.add(pylon_13);
			streetPanel.add(pylon_14);
			streetPanel.add(pylon_15);
			streetPanel.add(pylon_16);
			streetPanel.add(pylon_17);
			streetPanel.add(pylon_18);
			streetPanel.add(pylon_19);
			streetPanel.add(pylon_20);
			streetPanel.setBackground(Color.WHITE);
			
			frame.getContentPane().setVisible(true);
			
			for(int i=0; i<generation2.length; i++) {
				if(generation1[i] != null){
					streetPanel.remove(generation1[i].getAutoPanel());
					generation1[i] = null;
				}
				for(int j=0; j<generation2[0].length; j++) {
					if(generation2[i][j] != null){
						streetPanel.remove(generation2[i][j].getAutoPanel());
						generation2[i][j] = null;
					}
				}
			}
			streetPanel.validate();
			anzahlAutos = 5;
			troedelfaktor = 0;
			Simulation1 = new EinspurigeSimulation(troedelfaktor);
			simulation = 1;
			generation = 0;
			((SimulationPanel) streetPanel).setSimulation(simulation);
			textAreaStreet.setText("Noch keine Simulation gestartet...");
			textAreaInfo.setText("Noch keine Simulation gestartet...");
			btnZufaelligeStrasse.setEnabled(true);
			btnNaechsteGeneration.setEnabled(false);
			btnSpielfeldLeeren.setEnabled(false);
		}
	}
	private class SwingActionZweispurig extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = -6590936653316038846L;
		public SwingActionZweispurig() {
			putValue(NAME, "Zweispurige Stra\u00DFe");
			putValue(SHORT_DESCRIPTION, "Öffnet die Simulation zur zweispurigen Straße.");
		}
		public void actionPerformed(ActionEvent e) {
			streetPanel.remove(pylon_1);
			streetPanel.remove(pylon_2);
			streetPanel.remove(pylon_3);
			streetPanel.remove(pylon_4);
			streetPanel.remove(pylon_5);
			streetPanel.remove(pylon_6);
			streetPanel.remove(pylon_7);
			streetPanel.remove(pylon_8);
			streetPanel.remove(pylon_9);
			streetPanel.remove(pylon_10);
			streetPanel.remove(pylon_11);
			streetPanel.remove(pylon_12);
			streetPanel.remove(pylon_13);
			streetPanel.remove(pylon_14);
			streetPanel.remove(pylon_15);
			streetPanel.remove(pylon_16);
			streetPanel.remove(pylon_17);
			streetPanel.remove(pylon_18);
			streetPanel.remove(pylon_19);
			streetPanel.remove(pylon_20);
			
			frame.getContentPane().setVisible(true);
			
			for(int i=0; i<generation2.length; i++) {
				if(generation1[i] != null){
					streetPanel.remove(generation1[i].getAutoPanel());
					generation1[i] = null;
				}
				for(int j=0; j<generation2[0].length; j++) {
					if(generation2[i][j] != null){
						streetPanel.remove(generation2[i][j].getAutoPanel());
						generation2[i][j] = null;
					}
				}
			}
			streetPanel.validate();
			anzahlAutos = 5;
			troedelfaktor = 0;
			Simulation2 = new ZweispurigeSimulation(troedelfaktor);
			simulation = 2;
			generation = 0;
			((SimulationPanel) streetPanel).setSimulation(simulation);
			textAreaStreet.setText("Noch keine Simulation gestartet...");
			textAreaInfo.setText("Noch keine Simulation gestartet...");
			btnZufaelligeStrasse.setEnabled(true);
			spinnerAutos.setEnabled(true);
			rdbtnZufaelligeStrasse.setSelected(true);
			btnNaechsteGeneration.setEnabled(false);
			btnSpielfeldLeeren.setEnabled(false);
			
		}
	}
}
