package zellvermehrung;
import java.awt.*;
import java.awt.event.*;

class SimulationCanvas extends Canvas {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 7203466559027506428L;
	private boolean[][] gameArray = new boolean[40][40]; 
	
	public SimulationCanvas(){
		setSize(604,604);
		for(int i=0; i<gameArray.length; i++){
            for(int j=0; j<gameArray[0].length; j++){
            	gameArray[i][j]=false; 
            }
        }
	}
	
	public void setGameArray(boolean[][] array){
		gameArray = array;
	}
	
	public boolean[][] getGameArray(){
		return gameArray;
	}
	
	public void paint(Graphics g){
		// Zuerst wird die Gitterdasrtellung für das Spiel gemalt.
		g.setColor(Color.black);
		for(int i=0; i<=40; i++){
			g.drawLine(2+i*15,2,2+i*15,602);
		}
		for(int j=0; j<41; j++){
			g.drawLine(2,2+j*15,602,2+j*15);
		}
		// Entsprechend der Werte im Array werden Kreise gemalt (lebende Zellen).
		for(int i=0; i<40; i++){
			for(int j=0; j<40; j++){
				if(gameArray[i][j]==true){
					g.setColor(Color.black); 
					g.fillOval(2+i*15+1,2+j*15+1,13,13);
				}
			}
		}
	}
	
   	protected void processMouseEvent(MouseEvent e){
    	if (e.getID() == MouseEvent.MOUSE_PRESSED) {
        	requestFocus();
         
         	int x,y,i,j;
			x=e.getX();
			y=e.getY();
			// Ermittle aus der x und y Position der Maus die Zelle des Automaten,
			// in die geklickt wurde, und ?ndere ihren Zustand.
			i=x/15;
			j=y/15;
			if((i>=0) && (i<40) && (j>=0) && (j<40)){ 
				if(gameArray[i][j]==true){
					gameArray[i][j]=false;
				}else{
					gameArray[i][j]=true;
				}
				repaint();
			}
		}
      	super.processMouseEvent(e);
   	}
	
   
}
