package zellvermehrung;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.EmptyBorder;

import java.io.*;
import java.util.Random;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;


public class ZellvermehrungBoard extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7405606976315670521L;
	private JPanel contentPane;
	private static Component canvas;
	private JLabel lblLebendeZellen;
	private JLabel lblGeneration;
	private JLabel lblMillisekunden;
	JButton btnStart;
	JButton btnStop;
	JButton btnZufaelligesSpiel;
	JButton btnSpielfeldLeeren;
	JButton btnEinzelschritt;
	
	Timer t;
	int delay = 1000;
	boolean started = false;
	
	private final Action actionOpen = new SwingActionOpen();
	private final Action actionSave = new SwingActionSave();

	static Zellvermehrung Spiel = new Zellvermehrung();
	int generation = 0;

	/**
	 * Create the frame.
	 */
	public ZellvermehrungBoard() {
		setMinimumSize(new Dimension(1200, 750));
		setPreferredSize(new Dimension(1000, 1000));
		setSize(new Dimension(800, 800));
		setTitle("Applet - Simulation zur Zelvermehrung");
		setBackground(Color.WHITE);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 726, 587);
		
		JMenuBar menuBar = new JMenuBar();
		menuBar.setBackground(Color.WHITE);
		setJMenuBar(menuBar);
		
		JMenu mnDatei = new JMenu("Datei");
		menuBar.add(mnDatei);
		
		JMenuItem mntmDateiffnen = new JMenuItem("Öffnen");
		mntmDateiffnen.setAction(actionOpen);
		mnDatei.add(mntmDateiffnen);
		
		JMenuItem mntmSpeichernUnter = new JMenuItem("Speichern unter");
		mntmSpeichernUnter.setAction(actionSave);
		mnDatei.add(mntmSpeichernUnter);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.X_AXIS));
		
		Component horizontalStrut_1 = Box.createHorizontalStrut(20);
		contentPane.add(horizontalStrut_1);
		
		canvas = new SimulationCanvas();
		contentPane.add(canvas);
		canvas.setEnabled(false);
		canvas.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				Spiel.setAktuelleGeneration(((SimulationCanvas) canvas).getGameArray());
			}
		});
		canvas.setPreferredSize(new Dimension(605, 605));
		canvas.setMinimumSize(new Dimension(605, 605));
		canvas.setMaximumSize(new Dimension(605, 605));
		canvas.setSize(new Dimension(605, 605));
		canvas.setBackground(new Color(211, 211, 211));
		canvas.setSize(600,600);
		
		Component horizontalStrut = Box.createHorizontalStrut(20);
		contentPane.add(horizontalStrut);
		
		Panel panel_buttons = new Panel();
		panel_buttons.setMaximumSize(new Dimension(400, 600));
		contentPane.add(panel_buttons);
		GridBagLayout gbl_panel_buttons = new GridBagLayout();
		gbl_panel_buttons.columnWidths = new int[]{140, 144, 165, 140, 0};
		gbl_panel_buttons.rowHeights = new int[]{0, 0, 29, 0, 0, 0, 0, 0, 0, 0, 0, 0};
		gbl_panel_buttons.columnWeights = new double[]{0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		gbl_panel_buttons.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE};
		panel_buttons.setLayout(gbl_panel_buttons);
		
		// Label fuer die Anzeige der aktuellen Generation
		lblGeneration = new JLabel("Generation: " + generation);
		GridBagConstraints gbc_lblGeneration = new GridBagConstraints();
		gbc_lblGeneration.insets = new Insets(0, 0, 5, 5);
		gbc_lblGeneration.gridx = 0;
		gbc_lblGeneration.gridy = 0;
		panel_buttons.add(lblGeneration, gbc_lblGeneration);
		
		// Label fuer die Anzeige der lebenden Zellen
		lblLebendeZellen = new JLabel("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
		GridBagConstraints gbc_lblLebendeZellen = new GridBagConstraints();
		gbc_lblLebendeZellen.insets = new Insets(0, 0, 5, 5);
		gbc_lblLebendeZellen.gridx = 1;
		gbc_lblLebendeZellen.gridy = 0;
		panel_buttons.add(lblLebendeZellen, gbc_lblLebendeZellen);
		
		// Checkbox zum Aktivieren/Deaktivieren des Freihand Modus, bei dem man selbst Muster ins Canvas zeichnen kann.
		JCheckBox chckbxFreihandModus = new JCheckBox("Freihand Modus");
		chckbxFreihandModus.setToolTipText("Ist der Freihand Modus ausgewählt, können eigene Startkonfigurationen durch Klicken auf dem Spielfeld gezeichnet werden.");
		chckbxFreihandModus.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if(arg0.getStateChange() == 1 ){
					canvas.setEnabled(true);
				} else {
					canvas.setEnabled(false);
				}
			}
		});
		chckbxFreihandModus.setSelected(true);
		GridBagConstraints gbc_chckbxFreihandModus = new GridBagConstraints();
		gbc_chckbxFreihandModus.insets = new Insets(0, 0, 5, 5);
		gbc_chckbxFreihandModus.gridx = 2;
		gbc_chckbxFreihandModus.gridy = 0;
		panel_buttons.add(chckbxFreihandModus, gbc_chckbxFreihandModus);
		
		Component verticalStrut_1 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_1 = new GridBagConstraints();
		gbc_verticalStrut_1.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_1.gridx = 1;
		gbc_verticalStrut_1.gridy = 2;
		panel_buttons.add(verticalStrut_1, gbc_verticalStrut_1);
		
		// Label fuer die Anzeige der zu berechnenden Generationen.
		JLabel lblGeschwindigkeit = new JLabel("Geschwindigkeit: ");
		GridBagConstraints gbc_lblGeschwindigkeit = new GridBagConstraints();
		gbc_lblGeschwindigkeit.insets = new Insets(0, 0, 5, 5);
		gbc_lblGeschwindigkeit.gridx = 0;
		gbc_lblGeschwindigkeit.gridy = 3;
		panel_buttons.add(lblGeschwindigkeit, gbc_lblGeschwindigkeit);
		
		//Slider fuer die Geschwindigkeit, in der die einzelnen Schritte angezeigt werden sollen. [0,2000] 
		JSlider slider = new JSlider(JSlider.HORIZONTAL, 0, 2000, delay);
		slider.setToolTipText("Stellt die Geschwindigkeit ein, mit der die Simulation abgespielt werden soll, sobal der Start-Button gedrückt wird.");
		slider.setMaximumSize(new Dimension(500, 29));
		slider.setMinimumSize(new Dimension(500, 29));
		slider.setSnapToTicks(true);
		slider.setSize(new Dimension(250, 29));
		slider.setMajorTickSpacing(500);
		slider.setMinorTickSpacing(50);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				JSlider s = (JSlider)e.getSource();
		        if (!s.getValueIsAdjusting()) {
		            delay = (int)s.getValue();
		            lblMillisekunden.setText(delay + " Millisekunden");
		            t.setDelay(delay);
		        } 
			}
		});
		GridBagConstraints gbc_slider = new GridBagConstraints();
		gbc_slider.insets = new Insets(0, 0, 5, 5);
		gbc_slider.gridx = 1;
		gbc_slider.gridy = 3;
		panel_buttons.add(slider, gbc_slider);
		
		lblMillisekunden = new JLabel(delay + " Millisekunden");
		GridBagConstraints gbc_lblMillisekunden = new GridBagConstraints();
		gbc_lblMillisekunden.insets = new Insets(0, 0, 5, 5);
		gbc_lblMillisekunden.gridx = 2;
		gbc_lblMillisekunden.gridy = 3;
		panel_buttons.add(lblMillisekunden, gbc_lblMillisekunden);
		
		Component verticalStrut = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut = new GridBagConstraints();
		gbc_verticalStrut.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut.gridx = 1;
		gbc_verticalStrut.gridy = 4;
		panel_buttons.add(verticalStrut, gbc_verticalStrut);
		
		btnStart = new JButton("Start");
		btnStart.setToolTipText("Spielt die Simulation automatisch mit der ausgewählten Geschwindigkeit ab.");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(!started && btnStart.isEnabled()){
					ActionListener al = new ActionListener() {
						public void actionPerformed(ActionEvent evt) {
							Spiel.berechneNaechsteGeneration();
							Spiel.zaehleLebendeZellen();
							generation++;
							lblGeneration.setText("Generation: " + generation);
							lblLebendeZellen.setText("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
							((SimulationCanvas) canvas).setGameArray(Spiel.getAktuelleGeneration());
							canvas.repaint();
						}
					};
					t = new Timer(delay,al);
					t.start();
					started = true;
					btnStart.setEnabled(false);
					btnStop.setEnabled(true);
					btnEinzelschritt.setEnabled(false);
					btnSpielfeldLeeren.setEnabled(false);
					btnZufaelligesSpiel.setEnabled(false);
				}
			}
		});
		
		//Button "Naechste Generation": Berechnet die nächste Generation
		btnEinzelschritt = new JButton("Einzelschritt");
		btnEinzelschritt.setToolTipText("Berechnet die nächste Generation und gibt sie auf dem Spielfeld aus.");
		btnEinzelschritt.setAlignmentX(Component.CENTER_ALIGNMENT);
		btnEinzelschritt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(btnEinzelschritt.isEnabled()) {
					Spiel.berechneNaechsteGeneration();
					Spiel.zaehleLebendeZellen();
					generation++;
					lblGeneration.setText("Generation: " + generation);
					lblLebendeZellen.setText("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
					((SimulationCanvas) canvas).setGameArray(Spiel.getAktuelleGeneration());
					canvas.repaint();
					btnSpielfeldLeeren.setEnabled(true);
				}
			}
		});
		GridBagConstraints gbc_btnEinzelschritt = new GridBagConstraints();
		gbc_btnEinzelschritt.insets = new Insets(0, 0, 5, 5);
		gbc_btnEinzelschritt.gridx = 0;
		gbc_btnEinzelschritt.gridy = 5;
		panel_buttons.add(btnEinzelschritt, gbc_btnEinzelschritt);
		GridBagConstraints gbc_btnStart = new GridBagConstraints();
		gbc_btnStart.insets = new Insets(0, 0, 5, 5);
		gbc_btnStart.gridx = 1;
		gbc_btnStart.gridy = 5;
		panel_buttons.add(btnStart, gbc_btnStart);
		
		btnStop = new JButton("Stop");
		btnStop.setToolTipText("Stoppt die automatische Simulation.");
		btnStop.setEnabled(false);
		btnStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if(btnStop.isEnabled()) {
					t.stop();
					started = false;
					btnStart.setEnabled(true);
					btnStop.setEnabled(false);
					btnEinzelschritt.setEnabled(true);
					btnSpielfeldLeeren.setEnabled(true);
				}
			}
		});
		GridBagConstraints gbc_btnStop = new GridBagConstraints();
		gbc_btnStop.insets = new Insets(0, 0, 5, 5);
		gbc_btnStop.gridx = 2;
		gbc_btnStop.gridy = 5;
		panel_buttons.add(btnStop, gbc_btnStop);
		
		Component verticalStrut_2 = Box.createVerticalStrut(20);
		GridBagConstraints gbc_verticalStrut_2 = new GridBagConstraints();
		gbc_verticalStrut_2.insets = new Insets(0, 0, 5, 5);
		gbc_verticalStrut_2.gridx = 1;
		gbc_verticalStrut_2.gridy = 7;
		panel_buttons.add(verticalStrut_2, gbc_verticalStrut_2);
		
		//Button "Spielfeld leeren": Leert das Spielfeld, sodass keine lebenden Zellen mehr vorhanden sind.
		btnSpielfeldLeeren = new JButton("Spielfeld leeren");
		btnSpielfeldLeeren.setToolTipText("Leert das Spielfeld für eine neue Simulation.");
		btnSpielfeldLeeren.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(btnSpielfeldLeeren.isEnabled()) {
					Spiel.initalisiereArray();
					generation = 0;
					Spiel.setLebendeZellen(0);
					lblGeneration.setText("Generation: " + generation);
					lblLebendeZellen.setText("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
					((SimulationCanvas) canvas).setGameArray(Spiel.getAktuelleGeneration());
					canvas.repaint();
					btnStop.setEnabled(false);
					btnSpielfeldLeeren.setEnabled(false);
					btnZufaelligesSpiel.setEnabled(true);
				}
			}
		});
		GridBagConstraints gbc_btnSpielfeldLeeren = new GridBagConstraints();
		gbc_btnSpielfeldLeeren.insets = new Insets(0, 0, 5, 5);
		gbc_btnSpielfeldLeeren.anchor = GridBagConstraints.WEST;
		gbc_btnSpielfeldLeeren.gridx = 0;
		gbc_btnSpielfeldLeeren.gridy = 8;
		panel_buttons.add(btnSpielfeldLeeren, gbc_btnSpielfeldLeeren);
		
		// Button "Zufaelliges Spiel": Erzeugt ein zuf?llig gef?lltes Spielfeld
		btnZufaelligesSpiel = new JButton("Zuf\u00E4lliges Spiel");
		btnZufaelligesSpiel.setToolTipText("Füllt das Spielfeld zufällig mit lebendigen Zellen.");
		btnZufaelligesSpiel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(btnZufaelligesSpiel.isEnabled()) {
					Random zufall = new Random();
					for(int i=0; i<40; i++){
						for(int j=0; j<40; j++){
							Spiel.getAktuelleGeneration()[i][j] = zufall.nextBoolean();
						}
					}
					generation = 0;
					Spiel.zaehleLebendeZellen();
					lblGeneration.setText("Generation: " + generation);
					lblLebendeZellen.setText("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
					((SimulationCanvas) canvas).setGameArray(Spiel.getAktuelleGeneration());
					canvas.repaint();		
					btnZufaelligesSpiel.setEnabled(false);
					btnStart.setEnabled(true);
					btnEinzelschritt.setEnabled(true);
					btnSpielfeldLeeren.setEnabled(true);
				}
			}
		});
		GridBagConstraints gbc_btnZufaelligesSpiel = new GridBagConstraints();
		gbc_btnZufaelligesSpiel.insets = new Insets(0, 0, 5, 5);
		gbc_btnZufaelligesSpiel.gridx = 2;
		gbc_btnZufaelligesSpiel.gridy = 8;
		panel_buttons.add(btnZufaelligesSpiel, gbc_btnZufaelligesSpiel);
		
	}
	
	/**
	 * Diese Methode setzt die Werte im Array aktuelleGeneration[][] entsprechend,
	 * wie sie in der zu oeffnenden Datei gelesen wurden.
	 * @param z repraesentiert eine Zeil der Datei.
	 * @param nr enthaelt die Zeilennummer der Datei.
	 */
	public void schreibeInArray(String z, int nr) {
		for(int i=0; i<40; i++){
			if(z.charAt(i) == '-'){
				Spiel.setAktuelleGeneration(i, nr, false);
			} else {
				Spiel.setAktuelleGeneration(i, nr, true);
			}
		}
	}
	
	/**
	 * Diese Methode liest die Werte aus dem Array aktelleGeneration[][] aus,
	 * die fuer das Speichern des Spielfeldes in einer Datei benoetigt werden.
	 * @param x x-Koordinate der aktuellen Spielfeld-Zelle.
	 * @param y y-Koordinate der aktuellen Spielfeld-Zelle.
	 * @return
	 */
	public boolean leseAusArray(int x, int y) {
		return Spiel.getAktuelleGeneration(x, y);
	}

	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ZellvermehrungBoard frame = new ZellvermehrungBoard();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
		
		
	}

	
	
	

	/**
	 * Klasse zum Oeffnen einer *.txt Datei, in der eine Startkonfiguration fuer das Spiel gespeichert ist.
	 * @author michaelawehling
	 *
	 */
	private class SwingActionOpen extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = -335225027913196472L;
		public SwingActionOpen() {
			putValue(NAME, "Öffnen");
			putValue(SHORT_DESCRIPTION, "Öffnet eine existierende Datei.");
		}
		public void actionPerformed(ActionEvent e) {
			btnEinzelschritt.setEnabled(true);
			btnStart.setEnabled(true);
			btnStop.setEnabled(false);
			if(started){
				t.stop();
				started = false;
			}
			btnZufaelligesSpiel.setEnabled(false);
			btnSpielfeldLeeren.setEnabled(true);
			Frame f = new Frame();
			FileDialog filedia = new FileDialog(f, "Datei öffnen", FileDialog.LOAD);
			filedia.setFile("Dateiname.txt");
			filedia.setVisible(true);
			String filename = filedia.getFile();
			String dirname = filedia.getDirectory();
			if (filename != null) {
			  // Datei oeffnen und zeilenweise auslesen
				try{
					File datei = new File(dirname + filename);
					if(isCorrectFile(datei)){
						FileReader fr = new FileReader(datei);
						BufferedReader br = new BufferedReader(fr);
						String zeile = "";
						int nummer = 0;
						while((zeile = br.readLine()) != null){
							schreibeInArray(zeile, nummer);
							nummer++;
						}
						br.close();
						generation = 0;
						Spiel.zaehleLebendeZellen();
						lblGeneration.setText("Generation: " + generation);
						lblLebendeZellen.setText("Lebende Zellen: " + Spiel.getLebendeZellen()  + " / 1600");
						((SimulationCanvas) canvas).setGameArray(Spiel.getAktuelleGeneration());
						canvas.repaint();
					} else {
						Frame errorFrame = new Frame();
						JOptionPane.showMessageDialog(errorFrame, "Ungültiges Dateiformat!", "Fehler", JOptionPane.ERROR_MESSAGE);
					}
				} catch(Exception except) {
					except.printStackTrace();
				}
				
			}
			filedia.dispose();
		}
		/**
		 * Die Methode überprüft, ob die zu öffnende Datei ein gültiges Format hat.
		 * @param datei Datei, die geöffnet werden soll.
		 * @return true, wenn die Datei gültig ist und false sonst.
		 */
		private boolean isCorrectFile(File datei) {
			try {
				FileReader fr = new FileReader(datei);
				BufferedReader br = new BufferedReader(fr);
				String zeile = "";
				int nummer = 0;
				while(((zeile = br.readLine()) != null) && (nummer < 40)){
					if(zeile.length() < 40){
						br.close();
						return false;
					}
					for(int i=0; i<40; i++){
						if((zeile.charAt(i) != '-') && (zeile.charAt(i) != '0')){
							System.out.println("Error at position " + i + " in line " + nummer + "! " + zeile.charAt(i) + " found!");
							br.close();
							return false;
						}
					}
					nummer++;
				}
				br.close();
				if(nummer < 40){
					return false;
				}
				return true;
			} catch(Exception except) {
				except.printStackTrace();
				return false;
			}
		}
	}
	
	/**
	 * Klasse zum Speichern einer *.txt Datei, in der die aktuelle Spielfeld-Konfiguration gespeichert wird.
	 * @author Michaela Wehling
	 *
	 */
	private class SwingActionSave extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 303061459268624933L;
		public SwingActionSave() {
			putValue(NAME, "Speichern");
			putValue(SHORT_DESCRIPTION, "Speichert das Muster in einer Datei.");
		}
		public void actionPerformed(ActionEvent e) {
			btnEinzelschritt.setEnabled(true);
			btnStart.setEnabled(true);
			btnStop.setEnabled(false);
			t.stop();
			started = false;
			btnZufaelligesSpiel.setEnabled(false);
			btnSpielfeldLeeren.setEnabled(true);
			Frame f = new Frame();
			FileDialog filedia = new FileDialog(f, "Datei speichern", FileDialog.SAVE);
			filedia.setFile("Dateiname.txt");
			filedia.setVisible(true);
			String filename = filedia.getFile();
			String dirname = filedia.getDirectory();
			if (filename != null) {
				// Datei speichern
				try{
					File datei = new File(dirname + filename);
					datei.createNewFile();
					FileWriter fw = new FileWriter(datei);
					BufferedWriter bw = new BufferedWriter(fw);
					for(int i=0; i<40; i++){
						for(int j=0; j<40; j++){
							if(leseAusArray(j,i) == true){
								bw.write('0');
							} else {
								bw.write('-');
							}
						}
						bw.write('\n');
					}
					bw.close();
				} catch(Exception except) {
					except.printStackTrace();
				}
			}
			filedia.dispose();
		}
	}
}
